{Unit to test if a longword is prime
Copyright (C) 2005-2010 Franco Milani
e-mail: nadir@solaris.polarhome.com or astlab@inwind.it
This software is part of the bigint package v. 1.8 (bigint.zip) available at:
http://www.polarhome.com/~franco/
http://www.polarhome.com:723/~nadir/software/
http://spazioinwind.libero.it/frm/software/
----------------------------------------------------------------------------
This software is released in the hope that it will be useful, but on
an as-is basis. No warranty of any kind is offered, either expressed
or implied, including, without limitation, the implied warranties of
merchantability and fitness for a particular purpose.
You can use or modify this unit for personal purposes. You can also
redistribute it, but only in the original unmodified form and keeping
intact any part, included the above copyright notice. Possible changes
in the distributed versions will be made only by the author according
to hints, requests or bug reports.
You may distribute software items that link this unit or part of it
provided that you inform the recipients that this unit is employed.
----------------------------------------------------------------------------
The function dwprime() implemented here returns 1 if the longword n is
prime or 0 otherwise. It uses a trial division by the first 67 primes and
a Miller-Rabin test to bases 2, 7 and 61 (see G. Jaeschke, "On strong
pseudoprimes to several bases", Mathematics of computation, 61 (1993)
915-926).
----------------------------------------------------------------------------}
{$packrecords 1}
{$asmmode intel}
{$ifndef ver1_0}{$calling oldfpccall}{$endif}
UNIT isprw;

INTERFACE

FUNCTION dwprime (n: longword): longint;

IMPLEMENTATION

CONST
pin: array [0..61] of byte =
(0,0,1,1,0,1,0,1,0,0,0,1,0,1,0,0,0,1,0,1,0,0,0,1,0,0,0,0,0,1,0,1,0,0,0,0,0,1,
0,0,0,1,0,1,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,1,0,1);
pmq: array [1..16] of byte =
(61,59,53,47,43,41,37,31,29,23,17,13,11,7,5,3);

VAR
k,d,e,kc,pm,i,t: longword;

FUNCTION dwprime (n: longword): longint; assembler;
ASM
                mov     ebx,[ebp+8]
                cmp     ebx,61
                ja      @@100
                lea     edi,pin
                xor     eax,eax
                mov     al,[edi+ebx]
                jmp     @@330
@@100:          test    ebx,1
                jz      @@130
                mov     pm,ebx
                lea     edi,pmq
                mov     esi,15
                xor     ecx,ecx
@@105:          mov     eax,ebx
                xor     edx,edx
                mov     cl,[edi+esi]
                div     ecx
                cmp     edx,0
                je      @@130
                dec     esi
                jns     @@105
                dec     ebx
                mov     k,ebx
                bsf     ecx,ebx
                mov     e,ecx
                jz      @@150
                dec     e
@@150:          shr     ebx,cl
                mov     d,ebx
                mov     kc,2
                mov     eax,2
                jmp     @@171
@@180:          mov     eax,7
                jmp     @@170
@@190:          mov     eax,61
@@170:          mov     ebx,d
@@171:          mov     ecx,pm
                cmp     ebx,1
                jne     @@200
                xor     edx,edx
                div     ecx
                mov     eax,edx
                jmp     @@210
@@200:          mov     edi,eax
                bsr     edx,ebx
                mov     t,edx
                bt      ebx,0
                jnc     @@220
                mov     esi,eax
                jmp     @@240
@@220:          mov     esi,1
@@240:          mov     i,1
@@250:          mov     eax,edi
                mul     edi
                cmp     edx,ecx
                jb      @@260
                mov     ebx,eax
                mov     eax,edx
                xor     edx,edx
                div     ecx
                mov     eax,ebx
@@260:          div     ecx
                mov     edi,edx
                mov     eax,d
                mov     ebx,i
                bt      eax,ebx
                jnc     @@270
                mov     eax,esi
                mul     edi
                cmp     edx,ecx
                jb      @@280
                mov     ebx,eax
                mov     eax,edx
                xor     edx,edx
                div     ecx
                mov     eax,ebx
@@280:          div     ecx
                mov     esi,edx
@@270:          inc     i
                dec     t
                jnz     @@250
                mov     eax,esi
@@210:          cmp     eax,1
                je      @@290
                cmp     eax,k
                je      @@290
                cmp     e,0
                je      @@130
                mov     esi,e
@@300:          mul     eax
                cmp     edx,ecx
                jb      @@310
                mov     ebx,eax
                mov     eax,edx
                xor     edx,edx
                div     ecx
                mov     eax,ebx
@@310:          div     ecx
                mov     eax,edx
                cmp     eax,k
                je      @@290
                cmp     eax,1
                je      @@130
@@320:          dec     esi
                jnz     @@300
                jmp     @@130
@@290:          dec     kc
                jz      @@190
                jns     @@180
@@120:          mov     eax,1
                jmp     @@330
@@130:          xor     eax,eax
@@330:
END;

END.
