{Unit to perform some 128-bit operations with qwords
Copyright (C) 2006-2010 Franco Milani
e-mail: nadir@solaris.polarhome.com or astlab@inwind.it
This unit is part of the bigint package v. 1.8 (bigint.zip) available at:
http://www.polarhome.com/~franco/
http://www.polarhome.com:723/~nadir/software/
http://spazioinwind.libero.it/frm/software/
-----------------------------------------------------------------------------
This software is released in the hope that it will be useful, but on
an as-is basis. No warranty of any kind is offered, either expressed
or implied, including, without limitation, the implied warranties of
merchantability and fitness for a particular purpose.
You can use or modify this unit for personal purposes. You can also
redistribute it, but only in the original unmodified form and keeping
intact any part, included the above copyright notice. Possible changes
in the distributed versions will be made only by the author according
to hints, requests or bug reports.
You may distribute software items that link this unit or part of it
provided that you inform the recipients that this unit is employed.
-----------------------------------------------------------------------------
qmulmod(a,b,c,d) evaluates d:=(a*b) mod c (c must be greater than zero).
qsqrmod(a,b,c) evaluates c:=(a*a) mod b (b must be greater than zero).
qmodexp(a,b,c,d) evaluates d:=(a**b) mod c (b and c must be greater than zero).
-----------------------------------------------------------------------------}
{$packrecords 1}
{$asmmode intel}
{$ifndef ver1_0}{$calling oldfpccall}{$endif}
UNIT qwext;

INTERFACE

{d:=(a*b) mod c. c must be greater than 0}
PROCEDURE qmulmod (a,b,c: qword; var d: qword);

{c:=(a*a) mod b. b must be greater than 0}
PROCEDURE qsqrmod (a,b: qword; var c: qword);

{d:=(a**b) mod c. b and c must be greater than 0}
PROCEDURE qmodexp (a,b,c: qword; var d: qword);

IMPLEMENTATION

VAR
nt: qword;
jk,ik,rc: longword;
reg_a,reg_b,reg_c,reg_s,reg_u: longword;
m: array [1..4] of longword;

PROCEDURE qmulmod (a,b,c: qword; var d: qword); assembler;
ASM
                mov     ebx,ebp
                add     ebx,8
                mov     esi,ebx
                add     esi,8
                lea     edi,m
                mov     eax,[ebp+8]
                mov     edx,[ebp+16]
                mul     edx
                mov     ecx,edx
                mov     [edi],eax
                cmp     dword ptr [ebp+12],0
                jne     @@100
                mov     eax,[ebp+8]
                mov     edx,[ebp+20]
                mul     edx
                add     ecx,eax
                adc     edx,0
                mov     [edi+4],ecx
                mov     [edi+8],edx
                mov     dword ptr [edi+12],0
                cmp     edx,0
                je      @@110
                mov     ecx,2
                jmp     @@120
@@110:          cmp     ecx,0
                je      @@130
                mov     ecx,1
                jmp     @@120
@@100:          cmp     dword ptr [ebp+20],0
                jne     @@140
                mov     eax,[ebp+16]
                mov     edx,[ebp+12]
                mul     edx
                add     ecx,eax
                adc     edx,0
                mov     [edi+4],ecx
                mov     [edi+8],edx
                mov     dword ptr [edi+12],0
                cmp     edx,0
                je      @@150
                mov     ecx,2
                jmp     @@120
@@150:          cmp     ecx,0
                je      @@130
                mov     ecx,1
                jmp     @@120
@@140:          mov     eax,[ebp+16]
                mov     edx,[ebp+12]
                mul     edx
                add     ecx,eax
                adc     edx,0
                mov     esi,edx
                mov     eax,[ebp+8]
                mov     edx,[ebp+20]
                mul     edx
                add     ecx,eax
                adc     edx,0
                mov     [edi+4],ecx
                mov     ecx,edx
                mov     eax,[ebp+12]
                mov     edx,[ebp+20]
                mul     edx
                add     eax,esi
                adc     edx,0
                add     eax,ecx
                adc     edx,0
                mov     [edi+8],eax
                mov     [edi+12],edx
                mov     ecx,2
                cmp     edx,0
                je      @@120
                inc     ecx
                jmp     @@120
@@130:          mov     esi,[ebp+32]
                cmp     dword ptr [ebp+28],0
                jne     @@160
                mov     ebx,[ebp+24]
                mov     eax,[edi]
                xor     edx,edx
                div     ebx
                mov     [esi],edx
                mov     dword ptr [esi+4],0
                jmp     @@170
@@160:          mov     eax,[edi]
                mov     [esi],eax
                mov     dword ptr [esi+4],0
                jmp     @@170
@@120:          mov     ebx,[ebp+24]
                mov     eax,[ebp+28]
                cmp     eax,0
                jne     @@180
                xor     edx,edx
@@190:          mov     eax,[edi+ecx*4]
                div     ebx
                dec     ecx
                jns     @@190
                mov     esi,[ebp+32]
                mov     [esi],edx
                mov     dword ptr [esi+4],0
                jmp     @@170
@@180:          mov     reg_c,ecx
                lea     edi,[edi+ecx*4]
                bsr     ecx,eax
                neg     ecx
                add     ecx,31
                shld    eax,ebx,cl
                shl     ebx,cl
                mov     reg_b,eax
                mov     reg_a,ebx
                xor     edx,edx
                mov     eax,[edi]
                mov     esi,edx
                sub     edi,4
                mov     ebx,[edi]
                shld    edx,eax,cl
                shld    eax,ebx,cl
@@200:          cmp     edx,reg_b
                je      @@210
                div     reg_b
                jmp     @@220
@@210:          add     edx,eax
                mov     eax,4294967295
                jnc     @@220
                sub     edi,4
                mov     esi,eax
                mov     eax,ebx
                mov     ebx,reg_c
                dec     ebx
                mov     reg_c,ebx
                pushf
                jz      @@230
                mov     ebx,[edi]
@@230:          add     eax,reg_a
                adc     edx,0
                sub     edx,reg_a
                jmp     @@240
@@220:          mov     esi,eax
                sub     edi,4
                mov     eax,ebx
                mov     ebx,reg_c
                dec     ebx
                mov     reg_c,ebx
                pushf
                jz      @@250
                mov     ebx,[edi]
@@250:          shld    eax,ebx,cl
                mov     reg_s,edx
                mov     reg_u,eax
                mov     eax,reg_a
                mul     esi
                sub     eax,reg_u
                sbb     edx,reg_s
                jb      @@260
                ja      @@270
                test    eax,eax
                jz      @@260
@@270:          dec     esi
                sub     eax,reg_a
                sbb     edx,reg_b
                jb      @@260
                ja      @@270
                test    eax,eax
                jnz     @@270
@@260:          neg     eax
                adc     edx,0
                neg     edx
@@240:          popf
                jnz     @@200
                shrd    eax,edx,cl
                shr     edx,cl
                mov     edi,[ebp+32]
                mov     [edi],eax
                mov     [edi+4],edx
@@170:
END;

PROCEDURE qsqrmod (a,b: qword; var c: qword); assembler;
ASM
                lea     edi,m
                mov     eax,[ebp+8]
                mul     eax
                mov     [edi],eax
                cmp     dword ptr [ebp+12],0
                jne     @@100
                mov     [edi+4],edx
                mov     dword ptr [edi+8],0
                mov     dword ptr [edi+12],0
                xor     ecx,ecx
                cmp     edx,0
                je      @@110
                inc     ecx
                jmp     @@120
@@100:          mov     ecx,edx
                mov     eax,[ebp+8]
                mov     edx,[ebp+12]
                mul     edx
                mov     reg_a,eax
                mov     reg_b,edx
                add     eax,ecx
                adc     edx,0
                mov     ecx,eax
                mov     esi,edx
                add     ecx,reg_a
                adc     reg_b,0
                mov     [edi+4],ecx
                mov     ecx,reg_b
                mov     eax,[ebp+12]
                mul     eax
                add     eax,ecx
                adc     edx,0
                add     eax,esi
                adc     edx,0
                mov     [edi+8],eax
                mov     [edi+12],edx
                mov     ecx,2
                cmp     edx,0
                je      @@120
                inc     ecx
                jmp     @@120
@@110:          mov     esi,[ebp+24]
                cmp     dword ptr [ebp+20],0
                jne     @@130
                mov     ebx,[ebp+16]
                mov     eax,[edi]
                xor     edx,edx
                div     ebx
                mov     [esi],edx
                mov     dword ptr [esi+4],0
                jmp     @@140
@@130:          mov     eax,[edi]
                mov     [esi],eax
                mov     dword ptr [esi+4],0
                jmp     @@140
@@120:          mov     ebx,[ebp+16]
                mov     eax,[ebp+20]
                cmp     eax,0
                jne     @@150
                xor     edx,edx
@@160:          mov     eax,[edi+ecx*4]
                div     ebx
                dec     ecx
                jns     @@160
                mov     esi,[ebp+24]
                mov     [esi],edx
                mov     dword ptr [esi+4],0
                jmp     @@140
@@150:          mov     reg_c,ecx
                lea     edi,[edi+ecx*4]
                bsr     ecx,eax
                neg     ecx
                add     ecx,31
                shld    eax,ebx,cl
                shl     ebx,cl
                mov     reg_b,eax
                mov     reg_a,ebx
                xor     edx,edx
                mov     eax,[edi]
                mov     esi,edx
                sub     edi,4
                mov     ebx,[edi]
                shld    edx,eax,cl
                shld    eax,ebx,cl
@@170:          cmp     edx,reg_b
                je      @@180
                div     reg_b
                jmp     @@190
@@180:          add     edx,eax
                mov     eax,4294967295
                jnc     @@190
                sub     edi,4
                mov     esi,eax
                mov     eax,ebx
                mov     ebx,reg_c
                dec     ebx
                mov     reg_c,ebx
                pushf
                jz      @@200
                mov     ebx,[edi]
@@200:          add     eax,reg_a
                adc     edx,0
                sub     edx,reg_a
                jmp     @@210
@@190:          mov     esi,eax
                sub     edi,4
                mov     eax,ebx
                mov     ebx,reg_c
                dec     ebx
                mov     reg_c,ebx
                pushf
                jz      @@220
                mov     ebx,[edi]
@@220:          shld    eax,ebx,cl
                mov     reg_s,edx
                mov     reg_u,eax
                mov     eax,reg_a
                mul     esi
                sub     eax,reg_u
                sbb     edx,reg_s
                jb      @@230
                ja      @@240
                test    eax,eax
                jz      @@230
@@240:          dec     esi
                sub     eax,reg_a
                sbb     edx,reg_b
                jb      @@230
                ja      @@240
                test    eax,eax
                jnz     @@240
@@230:          neg     eax
                adc     edx,0
                neg     edx
@@210:          popf
                jnz     @@170
                shrd    eax,edx,cl
                shr     edx,cl
                mov     edi,[ebp+24]
                mov     [edi],eax
                mov     [edi+4],edx
@@140:
END;

PROCEDURE qmodexp (a,b,c: qword; var d: qword); assembler;
ASM
                mov     eax,[ebp+8]
                mov     ebx,[ebp+12]
                lea     esi,nt
                mov     [esi],eax
                mov     [esi+4],ebx
                mov     esi,[ebp+32]
                mov     dword ptr [esi],1
                mov     dword ptr [esi+4],0
                mov     ebx,[ebp+20]
                cmp     ebx,0
                jne     @@100
                mov     eax,[ebp+16]
                cmp     eax,0
                je      @@110
                bsr     eax,eax
                jmp     @@110
@@100:          bsr     eax,ebx
                add     eax,32
@@110:          inc     eax
                mov     jk,eax
                mov     ik,0
@@120:          mov     ebx,ik
                cmp     ebx,32
                jb      @@130
                mov     eax,[ebp+20]
                jmp     @@140
@@130:          mov     eax,[ebp+16]
@@140:          bt      eax,ebx
                jnc     @@150
                mov     ebx,[ebp+32]
                lea     esi,nt
                lea     edi,m
                mov     eax,[ebx]
                mov     edx,[esi]
                mul     edx
                mov     ecx,edx
                mov     [edi],eax
                cmp     dword ptr [ebx+4],0
                jne     @@160
                mov     eax,[ebx]
                mov     edx,[esi+4]
                mul     edx
                add     ecx,eax
                adc     edx,0
                mov     [edi+4],ecx
                mov     [edi+8],edx
                mov     dword ptr [edi+12],0
                cmp     edx,0
                je      @@170
                mov     ecx,2
                jmp     @@180
@@170:          cmp     ecx,0
                je      @@190
                mov     ecx,1
                jmp     @@180
@@160:          cmp     dword ptr [esi+4],0
                jne     @@200
                mov     eax,[esi]
                mov     edx,[ebx+4]
                mul     edx
                add     ecx,eax
                adc     edx,0
                mov     [edi+4],ecx
                mov     [edi+8],edx
                mov     dword ptr [edi+12],0
                cmp     edx,0
                je      @@210
                mov     ecx,2
                jmp     @@180
@@210:          cmp     ecx,0
                je      @@190
                mov     ecx,1
                jmp     @@180
@@200:          mov     eax,[esi]
                mov     edx,[ebx+4]
                mul     edx
                add     ecx,eax
                adc     edx,0
                mov     rc,edx
                mov     eax,[ebx]
                mov     edx,[esi+4]
                mul     edx
                add     ecx,eax
                adc     edx,0
                mov     [edi+4],ecx
                mov     ecx,edx
                mov     eax,[ebx+4]
                mov     edx,[esi+4]
                mul     edx
                add     eax,rc
                adc     edx,0
                add     eax,ecx
                adc     edx,0
                mov     [edi+8],eax
                mov     [edi+12],edx
                mov     ecx,2
                cmp     edx,0
                je      @@180
                inc     ecx
                jmp     @@180
@@190:          mov     esi,[ebp+32]
                cmp     dword ptr [ebp+28],0
                jne     @@220
                mov     eax,[edi]
                mov     ecx,[ebp+24]
                xor     edx,edx
                div     ecx
                mov     [esi],edx
                mov     dword ptr [esi+4],0
                jmp     @@150
@@220:          mov     eax,[edi]
                mov     [esi],eax
                mov     dword ptr [esi+4],0
                jmp     @@150
@@180:          mov     ebx,[ebp+24]
                mov     eax,[ebp+28]
                cmp     eax,0
                jne     @@230
                xor     edx,edx
@@240:          mov     eax,[edi+ecx*4]
                div     ebx
                dec     ecx
                jns     @@240
                mov     esi,[ebp+32]
                mov     [esi],edx
                mov     dword ptr [esi+4],0
                jmp     @@150
@@230:          mov     reg_c,ecx
                lea     edi,[edi+ecx*4]
                bsr     ecx,eax
                neg     ecx
                add     ecx,31
                shld    eax,ebx,cl
                shl     ebx,cl
                mov     reg_b,eax
                mov     reg_a,ebx
                xor     edx,edx
                mov     eax,[edi]
                mov     esi,edx
                sub     edi,4
                mov     ebx,[edi]
                shld    edx,eax,cl
                shld    eax,ebx,cl
@@250:          cmp     edx,reg_b
                je      @@260
                div     reg_b
                jmp     @@270
@@260:          add     edx,eax
                mov     eax,4294967295
                jnc     @@270
                sub     edi,4
                mov     esi,eax
                mov     eax,ebx
                mov     ebx,reg_c
                dec     ebx
                mov     reg_c,ebx
                pushf
                jz      @@280
                mov     ebx,[edi]
@@280:          add     eax,reg_a
                adc     edx,0
                sub     edx,reg_a
                jmp     @@290
@@270:          mov     esi,eax
                sub     edi,4
                mov     eax,ebx
                mov     ebx,reg_c
                dec     ebx
                mov     reg_c,ebx
                pushf
                jz      @@300
                mov     ebx,[edi]
@@300:          shld    eax,ebx,cl
                mov     reg_s,edx
                mov     reg_u,eax
                mov     eax,reg_a
                mul     esi
                sub     eax,reg_u
                sbb     edx,reg_s
                jb      @@310
                ja      @@320
                test    eax,eax
                jz      @@310
@@320:          dec     esi
                sub     eax,reg_a
                sbb     edx,reg_b
                jb      @@310
                ja      @@320
                test    eax,eax
                jnz     @@320
@@310:          neg     eax
                adc     edx,0
                neg     edx
@@290:          popf
                jnz     @@250
                shrd    eax,edx,cl
                shr     edx,cl
                mov     edi,[ebp+32]
                mov     [edi],eax
                mov     [edi+4],edx
@@150:          dec     jk
                jz      @@330
                lea     edi,m
                lea     ebx,nt
                mov     eax,[ebx]
                mul     eax
                mov     [edi],eax
                cmp     dword ptr [ebx+4],0
                jne     @@340
                mov     [edi+4],edx
                mov     dword ptr [edi+8],0
                mov     dword ptr [edi+12],0
                xor     ecx,ecx
                cmp     edx,0
                je      @@350
                inc     ecx
                jmp     @@360
@@340:          mov     ecx,edx
                mov     eax,[ebx]
                mov     edx,[ebx+4]
                mul     edx
                mov     reg_a,eax
                mov     reg_b,edx
                add     eax,ecx
                adc     edx,0
                mov     ecx,eax
                mov     esi,edx
                add     ecx,reg_a
                adc     reg_b,0
                mov     [edi+4],ecx
                mov     ecx,reg_b
                mov     eax,[ebx+4]
                mul     eax
                add     eax,ecx
                adc     edx,0
                add     eax,esi
                adc     edx,0
                mov     [edi+8],eax
                mov     [edi+12],edx
                mov     ecx,2
                cmp     edx,0
                je      @@360
                inc     ecx
                jmp     @@360
@@350:          lea     esi,nt
                cmp     dword ptr [ebp+28],0
                jne     @@370
                mov     eax,[edi]
                mov     ecx,[ebp+24]
                xor     edx,edx
                div     ecx
                mov     [esi],edx
                mov     dword ptr [esi+4],0
                jmp     @@380
@@370:          mov     eax,[edi]
                mov     [esi],eax
                mov     dword ptr [esi+4],0
                jmp     @@380
@@360:          mov     ebx,[ebp+24]
                mov     eax,[ebp+28]
                cmp     eax,0
                jne     @@390
                xor     edx,edx
@@400:          mov     eax,[edi+ecx*4]
                div     ebx
                dec     ecx
                jns     @@400
                lea     esi,nt
                mov     [esi],edx
                mov     dword ptr [esi+4],0
                jmp     @@380
@@390:          mov     reg_c,ecx
                lea     edi,[edi+ecx*4]
                bsr     ecx,eax
                neg     ecx
                add     ecx,31
                shld    eax,ebx,cl
                shl     ebx,cl
                mov     reg_b,eax
                mov     reg_a,ebx
                xor     edx,edx
                mov     eax,[edi]
                mov     esi,edx
                sub     edi,4
                mov     ebx,[edi]
                shld    edx,eax,cl
                shld    eax,ebx,cl
@@410:          cmp     edx,reg_b
                je      @@420
                div     reg_b
                jmp     @@430
@@420:          add     edx,eax
                mov     eax,4294967295
                jnc     @@430
                sub     edi,4
                mov     esi,eax
                mov     eax,ebx
                mov     ebx,reg_c
                dec     ebx
                mov     reg_c,ebx
                pushf
                jz      @@440
                mov     ebx,[edi]
@@440:          add     eax,reg_a
                adc     edx,0
                sub     edx,reg_a
                jmp     @@450
@@430:          mov     esi,eax
                sub     edi,4
                mov     eax,ebx
                mov     ebx,reg_c
                dec     ebx
                mov     reg_c,ebx
                pushf
                jz      @@460
                mov     ebx,[edi]
@@460:          shld    eax,ebx,cl
                mov     reg_s,edx
                mov     reg_u,eax
                mov     eax,reg_a
                mul     esi
                sub     eax,reg_u
                sbb     edx,reg_s
                jb      @@470
                ja      @@480
                test    eax,eax
                jz      @@470
@@480:          dec     esi
                sub     eax,reg_a
                sbb     edx,reg_b
                jb      @@470
                ja      @@480
                test    eax,eax
                jnz     @@480
@@470:          neg     eax
                adc     edx,0
                neg     edx
@@450:          popf
                jnz     @@410
                shrd    eax,edx,cl
                shr     edx,cl
                lea     edi,nt
                mov     [edi],eax
                mov     [edi+4],edx
@@380:          inc     ik
                jmp     @@120
@@330:
END;

END.
